#!/usr/bin/env python
#from url2media import *

from youtube2media import *
from metacafe2media import *
from googlevideo2media import *
from myspace2media import *
from direct2media import *
from pornhub2media import *

import math
#class that downloads various videos

class Stream2HDD(object):
    def __init__(self,url,dest_dir,user=None,password=None):
        self.url=url
        self.dest_dir=dest_dir
        self.dest_file=None
        self.user=user
        self.password=password
        self.progress=0
        self.state="starting..."
        self.media_url=""
        self.download_counter=0
        self.Prep()

    #get media real URL using Url2media extension classes
    def Prep(self):
        #url2media=Youtube2media(self.url)
        if Youtube2media.ReUrl.match(self.url):
            self.Url2media=Youtube2media(self.url,self.user,self.password)
        elif Metacafe2media.ReUrl.match(self.url):
            self.Url2media=Metacafe2media(self.url,self.user,self.password)
        elif Googlevideo2media.ReUrl.match(self.url):
            self.Url2media=Googlevideo2media(self.url,self.user,self.password)
        elif Myspace2media.ReUrl.match(self.url):
            self.Url2media=Myspace2media(self.url,self.user,self.password)
        elif Pornhub2media.ReUrl.match(self.url):
            self.Url2media=Pornhub2media(self.url,self.user,self.password)
        else:
            self.Url2media=Direct2media(self.url,self.user,self.password)
            #print "i tu sie gowno wypiernicza"
            #raise Exception("service not supported")

        #url2media.checkUrl()
        self.Url2media.fetchThumbnail()
        self.dest_file=self.Url2media.getDestFilename()
        self.media_url=self.Url2media.url2media()





    def formatBytes(self,num_bytes):
            const_1k=1024
            try:
                exp = self.optimumKExp(num_bytes)
                suffix = 'bkMGTPEZY'[exp]
                if exp == 0:
                    return '%s%s' % (num_bytes, suffix)
                converted = float(num_bytes) / float(const_1k**exp)
                return '%.2f%s' % (converted, suffix)
            except IndexError:
                sys.exit('Error: internal error formatting number of bytes.')
    def optimumKExp(self,num_bytes):
        if num_bytes == 0:
            return 0
        return long(math.log(num_bytes, 1024))

    def newBlockSize(self,before, after, bytes):
            new_min = max(bytes / 2.0, 1.0)
            new_max = max(bytes * 2.0, 1.0)
            dif = after - before
            if dif < 0.0001:
                return int(new_max)
            rate = bytes / dif
            if rate > new_max:
                return int(new_max)
            if rate < new_min:
                return int(new_min)
            return int(rate)


    def Download(self,ProgressBar=None):
        self.state="Starting download"
        if not self.Url2media.checkUrl():
            self.state="URL Broken"
            raise Exception("Bad URL or no URL given")

        # Install cookie and proxy handlers
        #urllib2.install_opener(urllib2.build_opener(urllib2.ProxyHandler()))
        #urllib2.install_opener(urllib2.build_opener(urllib2.HTTPCookieProcessor()))
        video_data = self.Url2media.performRequest(self.media_url)
        #video_stream=self.Url2media.performRequest(self.media_url).read()
        video_file = open(self.dest_dir+"/"+self.dest_file+".flv", 'wb')

        self.media_len = long(video_data.info()['Content-length'])
        print "media len:"+str(self.media_len)
        self.media_len_str = self.formatBytes(self.media_len)
        block_size=10*1024
        self.state="Downloading: "
        #self.media_len_str

        while True:
            before = time.time()
            video_block = video_data.read(block_size)
            after = time.time()

            dl_bytes = len(video_block)
            self.download_counter=self.download_counter+dl_bytes
            print "downloaded: "+str(self.download_counter)
            self.rate=dl_bytes/(after-before)
            print "rate: "+str(self.rate)+" bytes/s"
            self.progress=float(self.download_counter)/float(self.media_len)
            print "progres :"+str(self.progress)
            if ProgressBar is not None:
                ProgressBar.set_fraction(self.progress)
                ProgressBar.set_text(str(math.floor(self.progress*100))+"%")
            if dl_bytes == 0:
                break
            #byte_counter += dl_bytes
            video_file.write(video_block)
            block_size = self.newBlockSize(before, after, dl_bytes)

